=begin
#Platform external API.

#Documentation of our Platform external API.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

require 'date'

module Shippo
  class Batch
    attr_accessor :batch_shipments

    # ID of the Carrier Account object to use as the default for all shipments in this Batch. The carrier account can be changed on a per-shipment basis by changing the carrier_account in the corresponding BatchShipment object.
    attr_accessor :default_carrier_account

    # Token of the service level to use as the default for all shipments in this Batch. The servicelevel can be changed on a per-shipment basis by changing the servicelevel_token in the corresponding BatchShipment object.
    attr_accessor :default_servicelevel_token

    # Print format of the label. If empty, will use the default format.
    attr_accessor :label_filetype

    # An array of URLs each pointing to a merged file of 100 labels each
    attr_accessor :label_url

    # A string of up to 100 characters that can be filled with any additional information you want to attach to the object.
    attr_accessor :metadata

    # Date and time of Batch creation
    attr_accessor :object_created

    # Unique identifier of the given Batch object
    attr_accessor :object_id

    # Username of the user who created the Address object.
    attr_accessor :object_owner

    attr_accessor :object_results

    # Date and time of last update to the Batch
    attr_accessor :object_updated

    # Batches that are VALIDATING are being created and validated. VALID batches can be purchased, INVALID batches cannot be purchased, INVALID BatchShipments must be removed. Batches that are in the PURCHASING state are being purchased, PURCHASED batches are finished purchasing.
    attr_accessor :status

    attr_accessor :test

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'batch_shipments' => :'batch_shipments',
        :'default_carrier_account' => :'default_carrier_account',
        :'default_servicelevel_token' => :'default_servicelevel_token',
        :'label_filetype' => :'label_filetype',
        :'label_url' => :'label_url',
        :'metadata' => :'metadata',
        :'object_created' => :'object_created',
        :'object_id' => :'object_id',
        :'object_owner' => :'object_owner',
        :'object_results' => :'object_results',
        :'object_updated' => :'object_updated',
        :'status' => :'status',
        :'test' => :'test'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'batch_shipments' => :'Object',
        :'default_carrier_account' => :'Object',
        :'default_servicelevel_token' => :'Object',
        :'label_filetype' => :'Object',
        :'label_url' => :'Object',
        :'metadata' => :'Object',
        :'object_created' => :'Object',
        :'object_id' => :'Object',
        :'object_owner' => :'Object',
        :'object_results' => :'Object',
        :'object_updated' => :'Object',
        :'status' => :'Object',
        :'test' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end
  
    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `Shippo::Batch` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `Shippo::Batch`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'batch_shipments')
        self.batch_shipments = attributes[:'batch_shipments']
      end

      if attributes.key?(:'default_carrier_account')
        self.default_carrier_account = attributes[:'default_carrier_account']
      end

      if attributes.key?(:'default_servicelevel_token')
        self.default_servicelevel_token = attributes[:'default_servicelevel_token']
      end

      if attributes.key?(:'label_filetype')
        self.label_filetype = attributes[:'label_filetype']
      end

      if attributes.key?(:'label_url')
        if (value = attributes[:'label_url']).is_a?(Array)
          self.label_url = value
        end
      end

      if attributes.key?(:'metadata')
        self.metadata = attributes[:'metadata']
      end

      if attributes.key?(:'object_created')
        self.object_created = attributes[:'object_created']
      end

      if attributes.key?(:'object_id')
        self.object_id = attributes[:'object_id']
      end

      if attributes.key?(:'object_owner')
        self.object_owner = attributes[:'object_owner']
      end

      if attributes.key?(:'object_results')
        self.object_results = attributes[:'object_results']
      end

      if attributes.key?(:'object_updated')
        self.object_updated = attributes[:'object_updated']
      end

      if attributes.key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.key?(:'test')
        self.test = attributes[:'test']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @batch_shipments.nil?
        invalid_properties.push('invalid value for "batch_shipments", batch_shipments cannot be nil.')
      end

      if @default_carrier_account.nil?
        invalid_properties.push('invalid value for "default_carrier_account", default_carrier_account cannot be nil.')
      end

      if @default_servicelevel_token.nil?
        invalid_properties.push('invalid value for "default_servicelevel_token", default_servicelevel_token cannot be nil.')
      end

      if @label_url.nil?
        invalid_properties.push('invalid value for "label_url", label_url cannot be nil.')
      end

      if @object_created.nil?
        invalid_properties.push('invalid value for "object_created", object_created cannot be nil.')
      end

      if @object_id.nil?
        invalid_properties.push('invalid value for "object_id", object_id cannot be nil.')
      end

      if @object_owner.nil?
        invalid_properties.push('invalid value for "object_owner", object_owner cannot be nil.')
      end

      if @object_results.nil?
        invalid_properties.push('invalid value for "object_results", object_results cannot be nil.')
      end

      if @object_updated.nil?
        invalid_properties.push('invalid value for "object_updated", object_updated cannot be nil.')
      end

      if @status.nil?
        invalid_properties.push('invalid value for "status", status cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @batch_shipments.nil?
      return false if @default_carrier_account.nil?
      return false if @default_servicelevel_token.nil?
      label_filetype_validator = EnumAttributeValidator.new('Object', ['PNG', 'PNG_2.3x7.5', 'PDF', 'PDF_2.3x7.5', 'PDF_4x6', 'PDF_4x8', 'PDF_A4', 'PDF_A6', 'ZPLII'])
      return false unless label_filetype_validator.valid?(@label_filetype)
      return false if @label_url.nil?
      return false if @object_created.nil?
      return false if @object_id.nil?
      return false if @object_owner.nil?
      return false if @object_results.nil?
      return false if @object_updated.nil?
      return false if @status.nil?
      status_validator = EnumAttributeValidator.new('Object', ['VALIDATING', 'VALID', 'INVALID', 'PURCHASING', 'PURCHASED'])
      return false unless status_validator.valid?(@status)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] label_filetype Object to be assigned
    def label_filetype=(label_filetype)
      validator = EnumAttributeValidator.new('Object', ['PNG', 'PNG_2.3x7.5', 'PDF', 'PDF_2.3x7.5', 'PDF_4x6', 'PDF_4x8', 'PDF_A4', 'PDF_A6', 'ZPLII'])
      unless validator.valid?(label_filetype)
        fail ArgumentError, "invalid value for \"label_filetype\", must be one of #{validator.allowable_values}."
      end
      @label_filetype = label_filetype
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] status Object to be assigned
    def status=(status)
      validator = EnumAttributeValidator.new('Object', ['VALIDATING', 'VALID', 'INVALID', 'PURCHASING', 'PURCHASED'])
      unless validator.valid?(status)
        fail ArgumentError, "invalid value for \"status\", must be one of #{validator.allowable_values}."
      end
      @status = status
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          batch_shipments == o.batch_shipments &&
          default_carrier_account == o.default_carrier_account &&
          default_servicelevel_token == o.default_servicelevel_token &&
          label_filetype == o.label_filetype &&
          label_url == o.label_url &&
          metadata == o.metadata &&
          object_created == o.object_created &&
          object_id == o.object_id &&
          object_owner == o.object_owner &&
          object_results == o.object_results &&
          object_updated == o.object_updated &&
          status == o.status &&
          test == o.test
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [batch_shipments, default_carrier_account, default_servicelevel_token, label_filetype, label_url, metadata, object_created, object_id, object_owner, object_results, object_updated, status, test].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        elsif attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        Shippo.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end  end
end
